package com.fs.provider.mapper;

import java.time.LocalDateTime;
import java.util.List;
import com.fs.provider.domain.ServiceOrder;
import com.fs.provider.vo.ServiceOrderStatisticsReqVO;
import com.fs.provider.vo.ServiceOrderStatisticsVO;
import com.fs.task.vo.GetTaskCompleteStatsVO;
import org.apache.ibatis.annotations.Param;

/**
 * 服务单信息Mapper接口
 *
 * @author fs
 * @date 2026-01-26
 */
public interface ServiceOrderMapper
{
    /**
     * 查询服务单信息
     *
     * @param id 服务单信息主键
     * @return 服务单信息
     */
    public ServiceOrder selectServiceOrderById(Long id);

    /**
     * 查询服务单信息列表
     *
     * @param serviceOrder 服务单信息
     * @return 服务单信息集合
     */
    public List<ServiceOrder> selectServiceOrderList(ServiceOrder serviceOrder);

    /**
     * 新增服务单信息
     *
     * @param serviceOrder 服务单信息
     * @return 结果
     */
    public int insertServiceOrder(ServiceOrder serviceOrder);

    /**
     * 修改服务单信息
     *
     * @param serviceOrder 服务单信息
     * @return 结果
     */
    public int updateServiceOrder(ServiceOrder serviceOrder);

    /**
     * 删除服务单信息
     *
     * @param id 服务单信息主键
     * @return 结果
     */
    public int deleteServiceOrderById(Long id);

    /**
     * 批量删除服务单信息
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteServiceOrderByIds(Long[] ids);

    int markAutoConfirmed(@Param("orderId") Long orderId,@Param("settlementTime") LocalDateTime settlementTime);


    List<Long> selectNeedAutoConfirmIds(@Param("limit") int limit);

    List<ServiceOrder> queryStatis(GetTaskCompleteStatsVO statisVO);

    /**
     * 服务单统计汇总（按部门分组）
     *
     * @param reqVO 查询条件
     * @return 统计结果列表
     */
    List<ServiceOrderStatisticsVO> selectServiceOrderStatistics(ServiceOrderStatisticsReqVO reqVO);

    /**
     * 服务单统计数量
     * @param reqVO 参数
     * @return Long
     */
    Long selectServiceOrderStatCount(ServiceOrderStatisticsReqVO reqVO);
}
